﻿using System;
using System.Collections.ObjectModel;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Markup;
using Infragistics.Controls.Grids;

namespace XamGridExpand
{
    public partial class MainPage : UserControl
    {
        bool isAdded = false;
        ObservableCollection<Person> lstCurrentData = new ObservableCollection<Person>();
        ObservableCollection<Person> lstChildren = new ObservableCollection<Person>();
        Row ActiveRow = null;
        bool IsAlreadyExpanded = false;
        string strSelectedID = "";
        App app;
        int iLevel = -1;

        public MainPage()
        {
            InitializeComponent();
            ////ObservableCollection<Person> child = new ObservableCollection<Person>();
            ////child.Add(new Person() { Name = "child1", Age = 50 });
            ////child.Add(new Person() { Name = "child2", Age = 51 });
            ////child.Add(new Person() { Name = "child3", Age = 52 });

            ////ObservableCollection<Person> data = new ObservableCollection<Person>();
            ////data.Add(new Person() { Name = "person1", Age = 90, Children = child });
            ////data.Add(new Person() { Name = "person2", Age = 90, Children = child });
            ////data.Add(new Person() { Name = "person3", Age = 90, Children = child });

            ////this.DataContext = data;

            ////xamGrid1.RowExpansionChanging += new EventHandler<CancellableRowExpansionChangedEventArgs>(xamGrid1_RowExpansionChanging);
            ////xamGrid1.ColumnLayoutAssigned += new EventHandler<ColumnLayoutAssignedEventArgs>(xamGrid1_ColumnLayoutAssigned);
        }

        #region Events for Main Page grids
        void xamGrid1_ColumnLayoutAssigned(object sender, ColumnLayoutAssignedEventArgs e)
        {

            try
            {
                TemplateColumn objTempleteColoumn;
                int iSubFormID = 7;
                StringBuilder CellTemp;

                if (e.ColumnLayout.Columns.Count == 0)
                {
                    if (iSubFormID != 999)
                    {
                        //if (_lstTempleteColoumns.Count == 0)
                        //{
                        CellTemp = new StringBuilder();
                        CellTemp.Append("<DataTemplate ");
                        CellTemp.Append("xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation' ");
                        CellTemp.Append("xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml'> ");
                        CellTemp.Append("<Grid>");
                        CellTemp.Append(" <TextBlock x:Name=\"txtNormal\" Text=\"{Binding Age}\"/>");
                        CellTemp.Append(" </Grid>");
                        CellTemp.Append(" </DataTemplate>");

                        objTempleteColoumn = new TemplateColumn()
                        {
                            HeaderText = "Age",
                            Key = "Age",
                            Width = new ColumnWidth(40, false),
                            MinimumWidth = 30,
                            ////MaximumWidth = 80,
                            IsFixed = FixedState.Left,
                            IsSortable = false,
                            IsResizable = true,
                            ItemTemplate = (DataTemplate)XamlReader.Load(CellTemp.ToString())
                        };

                        e.ColumnLayout.Columns.Add(objTempleteColoumn);
                    }
                    CellTemp = new StringBuilder();
                    CellTemp.Append("<DataTemplate ");
                    CellTemp.Append("xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation' ");
                    CellTemp.Append("xmlns:x='http://schemas.microsoft.com/winfx/2006/xaml'> ");
                    CellTemp.Append("<Grid>");
                    CellTemp.Append(" <TextBlock x:Name=\"txtNormal\" Text=\"{Binding Name}\" />");
                    CellTemp.Append(" <Image x:Name=\"imgNotes\" Source=\"../images/n_g.jpg\" Visibility=\"Visible\" Height=\"10\"");
                    CellTemp.Append(" HorizontalAlignment=\"Right\" Margin=\"0,1.4,0,0\" VerticalAlignment=\"Top\"></Image>");
                    CellTemp.Append(" </Grid>");
                    CellTemp.Append(" </DataTemplate>");


                    objTempleteColoumn = new TemplateColumn()
                    {
                        HeaderText = "Name",
                        Key = "Name",
                        Width = new ColumnWidth(250, false),
                        MinimumWidth = 110,
                        IsFixed = FixedState.Left,
                        IsSortable = false,
                        IsResizable = true,
                        ItemTemplate = (DataTemplate)XamlReader.Load(CellTemp.ToString())
                    };

                    e.ColumnLayout.Columns.Add(objTempleteColoumn);
                }
                e.ColumnLayout.HeaderVisibility = Visibility.Collapsed;
                int count = e.ColumnLayout.Columns.DataColumns.Count;
                if (count > 0)// && e.ColumnLayout.Columns.DataColumns.Count >= count - 1)
                {
                    e.ColumnLayout.Columns.DataColumns[count - 1].Width = ColumnWidth.Star;
                }
            }
            catch (Exception)
            {

                throw;
            }
        }

        void xamGrid1_RowExpansionChanging(object sender, CancellableRowExpansionChangedEventArgs e)
        {

        }

        void xamGrid1_CellClicked(object sender, CellClickedEventArgs e)
        {
            if (ActiveRow == null && e.Cell != null)
                ActiveRow = (Row)e.Cell.Row;

            Person objnode = new Person();
            lstCurrentData = (ObservableCollection<Person>)((XamGrid)sender).ItemsSource;

            Person Grantchild = new Person();
            Grantchild.Name = "Grantchild1";
            Grantchild.Age = 10;

            ((Person)e.Cell.Row.Data).Children.Add(Grantchild);

            ActiveRow.IsExpanded = true;
            ActiveRow = null;
            IsAlreadyExpanded = true;
        }

        private void xamGrid1_InitializeRow(object sender, Infragistics.Controls.Grids.InitializeRowEventArgs e)
        {
            if (!isAdded)
            {
                ////xamGrid1.Columns.Add(new TemplateColumnLayout() { Template = this.Resources["MyDataTemplate"] as DataTemplate, Key = "Children" });
                isAdded = true;
            }
            ////e.Row.IsExpanded = true;
        }

        private void XamGrid_Loaded(object sender, RoutedEventArgs e)
        {
            (sender as XamGrid).ItemsSource = ((sender as XamGrid).DataContext as Person).Children;
        }
        #endregion
    }

    public class Person
    {
        public Person()
        {
            Children = new ObservableCollection<Person>();
        }
        public int Age { get; set; }
        public string Name { get; set; }
        public ObservableCollection<Person> Children { get; set; }
    }

}
